Imported Debian version 2.4.3~trusty1
[deb_ffmpeg.git] / ffmpeg / tests / fate.sh
CommitLineData
2ba45a60
DM
1#! /bin/sh
2
3config=$1
4
5die(){
6 echo "$@"
7 exit 1
8}
9
10test -r "$config" || die "usage: fate.sh <config>"
11
12workdir=$(cd $(dirname $config) && pwd)
13make=make
14tar='tar c'
15
16. "$config"
17
18test -n "$slot" || die "slot not specified"
19test -n "$repo" || die "repo not specified"
20test -d "$samples" || die "samples location not specified"
21
22: ${branch:=master}
23
24lock(){
25 lock=$1/fate.lock
26 (set -C; exec >$lock) 2>/dev/null || return
27 trap 'rm $lock' EXIT
28}
29
30checkout(){
31 case "$repo" in
32 file:*|/*) src="${repo#file:}" ;;
33 git:*) git clone --quiet --branch "$branch" "$repo" "$src" ;;
34 esac
35}
36
37update()(
38 cd ${src} || return
39 case "$repo" in
40 git:*) git fetch --force && git reset --hard "origin/$branch" ;;
41 esac
42)
43
44configure()(
45 cd ${build} || return
46 ${shell} ${src}/configure \
47 --prefix="${inst}" \
48 --samples="${samples}" \
49 --enable-gpl \
50 --enable-memory-poisoning \
51 --enable-avresample \
52 ${arch:+--arch=$arch} \
53 ${cpu:+--cpu="$cpu"} \
54 ${cross_prefix:+--cross-prefix="$cross_prefix"} \
55 ${as:+--as="$as"} \
56 ${cc:+--cc="$cc"} \
57 ${ld:+--ld="$ld"} \
58 ${target_os:+--target-os="$target_os"} \
59 ${sysroot:+--sysroot="$sysroot"} \
60 ${target_exec:+--target-exec="$target_exec"} \
61 ${target_path:+--target-path="$target_path"} \
62 ${target_samples:+--target-samples="$target_samples"} \
63 ${extra_cflags:+--extra-cflags="$extra_cflags"} \
64 ${extra_ldflags:+--extra-ldflags="$extra_ldflags"} \
65 ${extra_libs:+--extra-libs="$extra_libs"} \
66 ${extra_conf}
67)
68
69compile()(
70 cd ${build} || return
71 ${make} ${makeopts} && ${make} install
72)
73
74fate()(
75 test "$build_only" = "yes" && return
76 cd ${build} || return
77 ${make} ${makeopts} -k fate
78)
79
80clean(){
81 rm -rf ${build} ${inst}
82}
83
84report(){
85 date=$(date -u +%Y%m%d%H%M%S)
86 echo "fate:0:${date}:${slot}:${version}:$1:$2:${comment}" >report
87# echo "fate:1:${date}:${slot}:${version}:$1:$2:${branch}:${comment}" >report
88 cat ${build}/config.fate >>report
89 cat ${build}/tests/data/fate/*.rep >>report || for i in ${build}/tests/data/fate/*.rep ; do cat "$i" >>report ; done
90 test -n "$fate_recv" && $tar report *.log | gzip | $fate_recv
91}
92
93fail(){
94 report "$@"
95 clean
96 exit
97}
98
99mkdir -p ${workdir} || die "Error creating ${workdir}"
100lock ${workdir} || die "${workdir} locked"
101cd ${workdir} || die "cd ${workdir} failed"
102
103src=${workdir}/src
104: ${build:=${workdir}/build}
105: ${inst:=${workdir}/install}
106
107test -d "$src" && update || checkout || die "Error fetching source"
108
109cd ${workdir}
110
111version=$(${src}/version.sh ${src})
112test "$version" = "$(cat version-$slot 2>/dev/null)" && exit 0
113echo ${version} >version-$slot
114
115rm -rf "${build}" *.log
116mkdir -p ${build}
117
118configure >configure.log 2>&1 || fail 3 "error configuring"
119compile >compile.log 2>&1 || fail 2 "error compiling"
120fate >test.log 2>&1 || fail 1 "error testing"
121report 0 success
122clean